VERSION 5.00
Begin VB.Form frmDOSOutput 
   Caption         =   "DOS Outputs"
   ClientHeight    =   5820
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7665
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   7665
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdConsoleEnc 
      Caption         =   "In Console"
      Height          =   375
      Left            =   6300
      TabIndex        =   10
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton cmdConsoleDec 
      Caption         =   "In Console"
      Height          =   375
      Left            =   6300
      TabIndex        =   9
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton cmdExecuteEnc 
      Caption         =   "OggEnc"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   1155
   End
   Begin VB.TextBox txtCommandEnc 
      Height          =   285
      Left            =   1320
      TabIndex        =   5
      Top             =   1140
      Width           =   4875
   End
   Begin VB.Frame Frame1 
      Caption         =   "Debug Results"
      Height          =   3495
      Left            =   60
      TabIndex        =   3
      Top             =   2220
      Width           =   7395
      Begin VB.TextBox txtOutputs 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00000000&
         Height          =   3135
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   4
         Top             =   240
         Width           =   7155
      End
   End
   Begin VB.TextBox txtCommandDec 
      Height          =   285
      Left            =   1320
      TabIndex        =   2
      Top             =   420
      Width           =   4875
   End
   Begin VB.CommandButton cmdExecuteDec 
      Caption         =   "OggDec"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   1155
   End
   Begin VB.Label lblProgress 
      Caption         =   "Progress:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   204
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   120
      TabIndex        =   8
      Top             =   1680
      Width           =   7335
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Command:"
      Height          =   195
      Left            =   1320
      TabIndex        =   7
      Top             =   900
      Width           =   750
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Command:"
      Height          =   195
      Left            =   1320
      TabIndex        =   1
      Top             =   180
      Width           =   750
   End
End
Attribute VB_Name = "frmDOSOutput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'DOSOutpus
'Capture the outputs of a DOS command
'Author: Marco Pipino
'marcopipino@libero.it
'28/02/2002


Option Explicit

Private WithEvents objDOS As DOSOutputs
Attribute objDOS.VB_VarHelpID = -1
Dim Codec As String


Private Sub cmdConsoleDec_Click()
Shell txtCommandDec.text, vbNormalFocus
End Sub

Private Sub cmdConsoleEnc_Click()
Shell txtCommandEnc.text, vbNormalFocus
End Sub

Private Sub cmdExecuteDec_Click()
    On Error GoTo errore
    Codec = "oggdec"
    objDOS.ExecuteCommand txtCommandDec.text
    Exit Sub
errore:
    MsgBox (Err.Description & " - " & Err.Source & " - " & CStr(Err.Number))
End Sub

Private Sub cmdExecuteEnc_Click()
    On Error GoTo errore
    Codec = "oggenc"
    MsgBox "    ,    "
    objDOS.ExecuteCommand txtCommandEnc.text
    Exit Sub
errore:
    MsgBox (Err.Description & " - " & Err.Source & " - " & CStr(Err.Number))
End Sub

Private Sub Form_Load()
    Set objDOS = New DOSOutputs
    
    txtCommandEnc.text = Chr$(34) & App.Path & "\oggenc.exe" & Chr$(34) & " " & Chr$(34) & App.Path & "\1.wav" & Chr$(34) & " -q 2 -o " & Chr$(34) & App.Path & "\1new.ogg" & Chr$(34)
    txtCommandDec.text = Chr$(34) & App.Path & "\oggdec.exe" & Chr$(34) & " " & Chr$(34) & App.Path & "\1.ogg" & Chr$(34) & " --output " & Chr$(34) & App.Path & "\1.wav" & Chr$(34)
End Sub

Private Sub Form_Unload(Cancel As Integer)
Set objDOS = Nothing
End
End Sub

Public Function Split2(ByVal text As String, Delimiter As String, Optional S1 As String, Optional S2 As String, Optional Compare As VbCompareMethod = vbBinaryCompare) As Long
Dim i As Long
S1 = ""
S2 = ""
i = InStr(1, text, Delimiter, Compare)
If i = 0 Then
    S1 = text
    Exit Function
End If
If i = 1 And Len(Delimiter) = Len(text) Then
    Exit Function
End If
If i = 1 Then
    S2 = Mid$(text, Len(Delimiter) + 1)
    Exit Function
End If
If i + Len(Delimiter) = Len(text) + 1 Then
    S1 = Mid$(text, 1, i - 1)
    Exit Function
End If
S1 = Mid$(text, 1, i - 1)
S2 = Mid$(text, i + Len(Delimiter))
End Function

Private Sub objDOS_ReceiveOutputs(CommandOutputs As String)
    txtOutputs.text = txtOutputs.text & CommandOutputs
    
    Dim S As String, A As Long
    Select Case LCase$(Codec)
        Case "oggdec"
            A = InStrRev(CommandOutputs, "]")
            If A > 0 Then
                A = InStrRev(CommandOutputs, "[", A)
                If A > 0 Then
                    S = Mid$(CommandOutputs, A + 1)
                    Split2 S, "%", S
                    S = Trim$(S)
                    
                    lblProgress.Caption = "Progress: " & S
                End If
            End If
        Case "oggenc"
            A = InStrRev(CommandOutputs, "%")
            If A > 0 Then
                A = InStrRev(CommandOutputs, "[", A)
                If A > 0 Then
                    S = Mid$(CommandOutputs, A + 1)
                    Split2 S, "%", S
                    S = Trim$(S)
                    
                    lblProgress.Caption = "Progress: " & S
                End If
            End If
    End Select
End Sub

Private Sub txtOutputs_Change()
    txtOutputs.SelStart = Len(txtOutputs.text)
    DoEvents
End Sub
